
#include "stdafx.h"
#include "video.h"
#include "CommandCtl.h"
#include <errno.h> 

#define ERRORNR_COMMAND_CONNECT 1601
#define ERRORSTR_COMMAND_CONNECT "Unable to Connect"
#define ERRORNR_COMMAND_BIND 1602
#define ERRORSTR_COMMAND_BIND "Unable to Bind"

IMPLEMENT_DYNCREATE(CCommandCtrl, COleControl)

BEGIN_MESSAGE_MAP(CCommandCtrl, COleControl)
	//{{AFX_MSG_MAP(CCommandCtrl)
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CCommandCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CCommandCtrl)
	DISP_PROPERTY_NOTIFY(CCommandCtrl, "ListenPort", m_listenPort, OnListenPortChanged, VT_I2)
	DISP_FUNCTION(CCommandCtrl, "SendCommand", SendCommand, VT_EMPTY, VTS_BSTR VTS_I2 VTS_BSTR)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CCommandCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()

BEGIN_EVENT_MAP(CCommandCtrl, COleControl)
	//{{AFX_EVENT_MAP(CCommandCtrl)
	EVENT_CUSTOM("OnCommand", FireOnCommand, VTS_BSTR  VTS_BSTR)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()

IMPLEMENT_OLECREATE_EX(CCommandCtrl, "VIDEO.CommandCtrl.1", 0xba23409a, 0xefd5, 0x11d1, 0xbd, 0xd0, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3)
IMPLEMENT_OLETYPELIB(CCommandCtrl, _tlid, _wVerMajor, _wVerMinor)
const IID BASED_CODE IID_DCommand = { 0xba234098, 0xefd5, 0x11d1, { 0xbd, 0xd0, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3 } };
const IID BASED_CODE IID_DCommandEvents = { 0xba234099, 0xefd5, 0x11d1, { 0xbd, 0xd0, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3 } };
static const DWORD BASED_CODE _dwCommandOleMisc = OLEMISC_INVISIBLEATRUNTIME | OLEMISC_SETCLIENTSITEFIRST | OLEMISC_INSIDEOUT | OLEMISC_CANTLINKINSIDE | OLEMISC_RECOMPOSEONRESIZE;
IMPLEMENT_OLECTLTYPE(CCommandCtrl, IDS_COMMAND, _dwCommandOleMisc)

BOOL CCommandCtrl::CCommandCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_COMMAND,
			IDB_COMMAND,
			afxRegApartmentThreading,
			_dwCommandOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

CCommandCtrl::CCommandCtrl()
{
	InitializeIIDs(&IID_DCommand, &IID_DCommandEvents);
   m_listenPort=0;
   hwndTarget=0;
}

CCommandCtrl::~CCommandCtrl()
{
   if (m_listenPort) { m_listenPort=0; OnListenPortChanged(); }
}

void CCommandCtrl::OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
   DrawOcxBitmap(this, pdc, rcBounds, IDB_COMMAND);
}

void CCommandCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);
}

void CCommandCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange
}

void CCommandCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX);
	dlgAbout.DoModal();
}

void CCommandCtrl::SendCommand(LPCTSTR host, short port, LPCTSTR txt) 
{
   Transport t(SOCK_STREAM);
   if (!t.Connect((char*)host,(u_short)port)) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_COMMAND_CONNECT), ERRORSTR_COMMAND_CONNECT, 0); return; }
   t.Send((char*)txt, strlen((char*)txt));
   t.Close();
}

void CCommandCtrl::OnListenPortChanged() 
{
   if (hwndTarget)
   {
      Suspend(); Terminate();
      mywnd->DestroyWindow(); delete mywnd; hwndTarget=0;
      delete tmp_txt;
      Close();
   }
   if (m_listenPort)
   {
      type=SOCK_STREAM;
      if (!Bind((u_short)m_listenPort)) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_COMMAND_BIND), ERRORSTR_COMMAND_BIND, 0); m_listenPort; return; }
      mywnd=new CCommandWindow(this);
      hwndTarget=mywnd->Create();
      tmp_txt=new char[2001];
      Start();
   }
	SetModifiedFlag();
}

void CCommandCtrl::Run(void)
{
   while(1)
   {
      Transport client=Accept(); if (client.IsInvalid()) break;
      while(1)
      {
	      int r=client.Receive(tmp_txt,2000); if (r==SOCKET_ERROR || r<=0) break;
         tmp_txt[r]=0;
	      tmp_peername=client.GetPeername();
         if (hwndTarget) ::SendMessage(hwndTarget,WM_THREADFIREEVENT,0,0);
      }
      client.Close();
   }
}

// ********************************************************************

BEGIN_MESSAGE_MAP(CCommandWindow, CWnd)
	ON_MESSAGE(WM_THREADFIREEVENT,OnFireEventForThread)
END_MESSAGE_MAP()

HWND CCommandWindow::Create()
{
	LPCTSTR classname=AfxRegisterWndClass(0);
	CWnd::CreateEx(NULL,classname,NULL,NULL,1,1,1,1,NULL,NULL); ASSERT(m_hWnd!=NULL);
	return m_hWnd;
}

LRESULT CCommandWindow::OnFireEventForThread(WPARAM wParam, LPARAM lParam)
{
	m_pControl->FireOnCommand((LPCTSTR)m_pControl->tmp_peername, (LPCTSTR)m_pControl->tmp_txt);
	return TRUE;
}
