
#include "stdafx.h"
#include "video.h"
#include "FrameControlCtl.h"

#define ABS(x) x>=0?x:-x

unsigned char kennung[5] = { 0xFE, 0xD5, 0x34, 0x21, 0 };
#define KENNUNGZ 4

extern long bmpsize(BITMAPINFOHEADER* bmph);
extern long bmphsize(BITMAPINFOHEADER* bmph);

IMPLEMENT_DYNCREATE(CFrameControlCtrl, COleControl)

BEGIN_MESSAGE_MAP(CFrameControlCtrl, COleControl)
	//{{AFX_MSG_MAP(CFrameControlCtrl)
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CFrameControlCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CFrameControlCtrl)
	DISP_FUNCTION(CFrameControlCtrl, "SendFrame", SendFrame, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CFrameControlCtrl, "Receive", Receive, VT_I4, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CFrameControlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()

BEGIN_EVENT_MAP(CFrameControlCtrl, COleControl)
	//{{AFX_EVENT_MAP(CFrameControlCtrl)
	EVENT_CUSTOM("ReadyToSend", FireReadyToSend, VTS_I4  VTS_I4)
	EVENT_CUSTOM("OnFrame", FireOnFrame, VTS_I4  VTS_I4  VTS_I4)
	EVENT_CUSTOM("FrameLost", FireFrameLost, VTS_NONE)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()

IMPLEMENT_OLECREATE_EX(CFrameControlCtrl, "VIDEO.FrameControlCtrl.1", 0x96872fab, 0xd44c, 0x11d1, 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3)
IMPLEMENT_OLETYPELIB(CFrameControlCtrl, _tlid, _wVerMajor, _wVerMinor)

const IID BASED_CODE IID_DFrameControl = { 0x96872fa9, 0xd44c, 0x11d1, { 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3 } };
const IID BASED_CODE IID_DFrameControlEvents = { 0x96872faa, 0xd44c, 0x11d1, { 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3 } };

static const DWORD BASED_CODE _dwFrameControlOleMisc =
	OLEMISC_INVISIBLEATRUNTIME |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CFrameControlCtrl, IDS_FRAMECONTROL, _dwFrameControlOleMisc)

BOOL CFrameControlCtrl::CFrameControlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_FRAMECONTROL,
			IDB_FRAMECONTROL,
			afxRegApartmentThreading,
			_dwFrameControlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

CFrameControlCtrl::CFrameControlCtrl()
{
	InitializeIIDs(&IID_DFrameControl, &IID_DFrameControlEvents);
   puffer=0;
   pufferpos=0;
   pufferlen=0;
}

CFrameControlCtrl::~CFrameControlCtrl()
{
   delete puffer;
}

void CFrameControlCtrl::OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
   DrawOcxBitmap(this, pdc, rcBounds, IDB_FRAMECONTROL);
}

void CFrameControlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);
}

void CFrameControlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange
}

void CFrameControlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX);
	dlgAbout.DoModal();
}

// ******************************************************************

// Kopiere max Bytes auf *var, oder bis Startflag erkannt
// return: Anzahl der Bytes; Negativ falls Startflag erkannt
long CFrameControlCtrl::copy(unsigned char* src, long size, unsigned char* &dst, long &max, int &vgl) 
{
   long taken=0;
   while ((max || vgl==KENNUNGZ) && size>0)
   { 
      if (dst) *(dst++)=*src;
      taken++; 

      if (vgl==KENNUNGZ)
      {
         vgl=0; 
         if ((*src)==0) return -taken;
         max++; if (dst) dst--;
      }
      else if ((*src)==kennung[vgl]) 
         vgl++;
      else
         vgl=((*src)==kennung[0])?1:0;

      src++;
      size--; 
      max--; 
   }
   return taken;
}

long CFrameControlCtrl::copy2(unsigned char* data1, long size1, unsigned char* data2, long size2, unsigned char *dst, long max, int &vgl) 
{
   long r1, r2=0;
   r1=copy(data1, size1, dst, max, vgl);
   if (r1>=0) r2=copy(data2, size2, dst, max, vgl);
   return (r2<0)?(r2-r1):(r1+r2);
}

void CFrameControlCtrl::SendFrame(long bmph, long data, long size) 
{
   BITMAPINFOHEADER *b=(BITMAPINFOHEADER *)bmph;
   long l=b->biSize+size;
   
   FireReadyToSend((long)kennung, KENNUNGZ+1);
   FireReadyToSend((long)(&l), 4);

   int vgl=0;
   readytosend(bmph, bmphsize(b), vgl);
   readytosend(data, size, vgl);
}

void CFrameControlCtrl::readytosend(long data, long size, int &vgl)
{
   unsigned char *mem=(unsigned char*)data;
   unsigned char *start=mem;
   while (size>0)
   {
      if (*mem==kennung[vgl])
      {
         vgl++;
         if (vgl>KENNUNGZ)
         {
            FireReadyToSend((long)start, (long)(mem-start+1));
            char i='x';
            FireReadyToSend((long)i, 1);
            start=mem+1;
            vgl=0;
         }
      }
      else
         vgl=(*mem==kennung[0])?1:0;
      mem++;
      size--;
   }
   if (start<mem) FireReadyToSend((long)start, (long)(mem-start));
}

long CFrameControlCtrl::Receive(long data1, long size1, long data2, long size2) 
{
	static int startflag=0, lenflag=0, vgl=0;
   static long l=0;
   long sf;

   if (size1+size2==0) return 0;
   if (!startflag)
   {
      sf=copy2((unsigned char*)data1, size1, (unsigned char*)data2, size2, 0, -1, vgl);
      if (sf<0) { startflag=1; return -sf; }
      return sf;
   }

   if (!lenflag)
   {
      if (size1+size2<4) return 0;
      sf=copy2((unsigned char*)data1, size1, (unsigned char*)data2, size2, (unsigned char *)(&l), 4, vgl);
      if (sf<0) return -sf;
      if (l>1000000) { startflag=0; return sf; }
      if (l>pufferlen) { delete puffer; pufferpos=puffer=new unsigned char[pufferlen=l]; } else pufferpos=puffer;
      lenflag=1;
      return sf;
   }

   sf=copy2((unsigned char*)data1, size1, (unsigned char*)data2, size2, pufferpos, l, vgl);
   if (sf<0) { lenflag=0; FireFrameLost(); return -sf; }
   l-=sf; pufferpos+=sf;
   if (!l)
   {
      BITMAPINFOHEADER *b=(BITMAPINFOHEADER *)puffer;
      FireOnFrame((long)puffer, (long)(puffer+bmphsize(b)), bmpsize(b));
      startflag=0;
      lenflag=0;
   }
   return sf;
}

